#!/bin/bash

# 获取环境变量
USER=${USER}
HOST=${HOST}
SUDO_PASS=${SUDO_PASS}
USER_HOME=/home/$USER

# 检查环境变量是否为空
if [ -z "$HOST" ]; then
  echo "Error: 远程主机地址不能为空"
  exit 1
fi

if [ -z "$USER" ]; then
  echo "Error: 用户名不能为空"
  exit 1
fi

if [ -z "$SUDO_PASS" ]; then
  echo "Error: sudo 密码不能为空"
  exit 1
fi

# 创建一个临时远程脚本文件
REMOTE_SCRIPT=$(mktemp)

cat << 'EOF' > $REMOTE_SCRIPT
#!/bin/bash

USER_HOME=$1

# 备份当前用户的 crontab
crontab -l > $USER_HOME/crontab_backup_$(date +\%Y\%m\%d\%H\%M\%S).bak

# 备份 root 用户的 crontab
sudo crontab -l > $USER_HOME/root_crontab_backup_$(date +\%Y\%m\%d\%H\%M\%S).bak
EOF

# 将远程脚本文件传输到远程主机
rsync -avz $REMOTE_SCRIPT $USER@$HOST:$USER_HOME/backup_crontab.sh

# 执行远程脚本文件
ssh $USER@$HOST "chmod +x $USER_HOME/backup_crontab.sh && $USER_HOME/backup_crontab.sh $USER_HOME"

# 删除临时脚本文件
rm $REMOTE_SCRIPT
ssh $USER@$HOST "rm $USER_HOME/backup_crontab.sh"
